# -*- coding: utf-8 -*-
"""
Created on Wed Oct 13 20:19:52 2021

@author: Taller
"""

import numpy as np
import matplotlib.pyplot as plt
from scipy import signal

#%%
N = 1000
L = 100

sig = np.zeros(N)
sig[N//2-L//2:N//2+L//2] = sig[N//2-L//2:N//2+L//2] + 1

l_p = 2*L
p =  np.ones(l_p+10)
p[0:5] = p[0:5]*0
p[-5:] = p[-5:]*0



plt.figure()
plt.title('Señales creadas')
plt.plot(np.arange(N) -N//2, sig, label = 'Señal', color = 'black')
plt.plot(np.arange(l_p+10) -(l_p+10)//2, p, label = 'plantilla', color = 'red')
plt.legend()
plt.grid()

#%%
# Correlación
cor = np.correlate(sig, p, mode = 'same')

plt.figure()
plt.title('Correlación de la señal')
plt.plot(np.arange(N) -N//2, cor)
plt.grid()

#%%
l_p = L//2
p_1 =  np.ones(l_p+10)
p_1[0:5] = p_1[0:5]*0
p_1[-5:] = p_1[-5:]*0

l_p = L
p_2 =  np.ones(l_p+10)
p_2[0:5] = p_2[0:5]*0
p_2[-5:] = p_2[-5:]*0

l_p = 2*L
p_3 =  np.ones(l_p+10)
p_3[0:5] = p_3[0:5]*0
p_3[-5:] = p_3[-5:]*0

cor_1 = np.correlate(sig, p_1, mode = 'same')
cor_2 = np.correlate(sig, p_2, mode = 'same')
cor_3 = np.correlate(sig, p_3, mode = 'same')

plt.figure()
plt.title('Correlación de la señal')
plt.plot(np.arange(N) -N//2, cor_1, label = 'Plantilla < L')
plt.plot(np.arange(N) -N//2, cor_2, label = 'Plantilla = L')
plt.plot(np.arange(N) -N//2, cor_3, label = 'Plantilla > L')
plt.legend()
plt.grid()
#%%

N = 1000 # Largo de la señal
L_1 = 50 # Ancho de pulsos
L_3 = 100 # Ancho de pulsos

# Creación de la señal
sig = np.zeros(N)

# Tren de pulsos de ancho L_1
sig[100:100+L_1] = sig[100:100+L_1] + 1
sig[200:200+L_1] = sig[200:200+L_1] + 1
sig[300:300+L_1] = sig[300:300+L_1] - 1

# Tren de pulsos de ancho L_3
sig[500:500+L_3] = sig[500:500+L_3] + 1
sig[650:650+L_3] = sig[650:650+L_3] + 1
sig[800:800+L_3] = sig[800:800+L_3] - 1

plt.figure()
plt.title('Señal de pulsos creada')
plt.plot(sig)
plt.grid()

#%%
# Creación de las plantillas
p_1 = np.ones(L_1+10) # Plantilla 1
p_1[0:5] = p_1[0:5]*0
p_1[-5:] = p_1[-5:]*0
 
L_2 = (L_3+L_1)//2
p_2 = np.ones(L_2+10) # Plantilla intermedia
p_2[0:5] = p_2[0:5]*0
p_2[-5:] = p_2[-5:]*0

p_3 = np.ones(L_3+10) # Plantilla 2
p_3[0:5] = p_3[0:5]*0
p_3[-5:] = p_3[-5:]*0


fig, ax = plt.subplots(3, sharex= True)
fig.suptitle('Plantillas')
ax[0].plot(p_1, label = 'Plantilla 1', color = 'blue')
ax[1].plot(p_2, label = 'Plantilla 2', color = 'orange')
ax[2].plot(p_3, label = 'Plantilla 3', color = 'yellow')
ax[0].legend()
ax[1].legend()
ax[2].legend()

#%%
# Cálculo de la correlación
cor_1 = np.correlate(sig, p_1, 'same')
cor_2 = np.correlate(sig, p_2, 'same')
cor_3 = np.correlate(sig, p_3, 'same')

plt.figure()
plt.title('Correlación con la plantilla 1')
plt.plot(cor_1)
plt.grid()

plt.figure()
plt.title('Correlación con la plantilla 2')
plt.plot(cor_2)
plt.grid()

plt.figure()
plt.title('Correlación con la plantilla 3')
plt.plot(cor_3)
plt.grid()

#%%

fig, ax = plt.subplots(2, sharex= True)
fig.suptitle('Correlación')
ax[0].plot(cor_1, label = 'Correlación con la Plantilla 1', color = 'blue')
ax[0].plot(cor_2, label = 'Correlación con la Plantilla 2', color = 'orange')
ax[0].plot(cor_3, label = 'Correlación con la Plantilla 3', color = 'yellow')
ax[1].plot(sig, label = 'Señal', color = 'black')
ax[0].legend()
ax[1].legend()
ax[0].grid()
ax[1].grid()
#%%
# Normalización de las plantillas
p_1_n = p_1/np.sqrt(np.correlate(p_1,p_1))
p_2_n = p_2/np.sqrt(np.correlate(p_2,p_2))
p_3_n = p_3/np.sqrt(np.correlate(p_3,p_3))
sig_n = sig/np.sqrt(np.correlate(sig,sig))

plt.figure()
plt.title('Plantillas normalizadas')
plt.plot(p_1_n, label = 'Plantilla 1', color = 'blue')
plt.plot(p_2_n, label = 'Plantilla 2', color = 'orange')
plt.plot(p_3_n, label = 'Plantilla 3', color = 'yellow')
plt.legend()

#%%
# Cálculo de la correlación con plantillas normalizadas
cor_1_n = np.correlate(sig_n, p_1_n, 'same')
cor_2_n = np.correlate(sig_n, p_2_n, 'same')
cor_3_n = np.correlate(sig_n, p_3_n, 'same')

plt.figure()
plt.title('Correlación con plantillas normalizadas')
plt.plot(cor_1_n, label = 'Correlación con la Plantilla 1', color = 'blue')
plt.plot(cor_2_n, label = 'Correlación con la Plantilla intermedia', color = 'orange')
plt.plot(cor_3_n, label = 'Correlación con la plantilla Plantilla 2', color = 'yellow')
plt.plot(sig, label = 'Señal', color = 'black')
plt.legend()
plt.grid()

#%% Señal para espectrograma

fs = 1000
time = np.arange(0,1,1/fs)
s_1 = np.sin(time[0:250]*10*2*np.pi)
s_2 = np.sin(time[250:500]*50*2*np.pi)
s_3 = np.sin(time[500:750]*100*2*np.pi)
s_4 = np.sin(time[750:]*200*2*np.pi)

s = np.concatenate([s_1, s_2, s_3, s_4])
plt.figure()
plt.plot(time, s)

#%% Espectrograma

f, t, Sxx = signal.spectrogram(s, fs)
plt.figure()
plt.pcolormesh(t, f, Sxx, shading='gouraud')
plt.ylabel('Frequency [Hz]')
plt.xlabel('Time [sec]')